//+------------------------------------------------------------------+
//|                                           EGEN Trend Teacher.mq4 |
//|                             Copyright  2009, EGEN Software LTD. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property copyright "Copyright  2009, EGEN Software LTD."
#property link      "http://www.metaquotes.net"

#define  SIZE  625

double   ARRAY[SIZE][SIZE];
double   PRICE; 
int      MAGIC.1; 
int      MAGIC.2; 
int      FILE; 
datetime TIME;

bool EQ(int value1, int value2)
{
   return(value1==value2);
}

datetime TIME()
{
   return(iTime(NULL,0,0));
}

int TREND(int mode)
{
   return(iCustom(NULL,0,"iTrend",mode,0));
}

int FAST()
{
   return(TREND(0));
}

int SLOW()
{
   return(TREND(1));
}

int MAGIC()
{
   int F=(FAST()+12)*25;
   int S=(SLOW()+12);
   return(F+S);   
}

double PRICE()
{
   return((Ask+Bid)/2);
}

bool WAVE.0(int magic)
{
   if(MAGIC.1<0) 
      MAGIC.1=magic; else return(false);
   return(true);      
}

bool WAVE.1(int magic)
{
  return(EQ(MAGIC.1,magic));
}

bool WAVE.2(int magic)
{
   if(MAGIC.2<0) 
      MAGIC.2=MAGIC.1; else return(false);
   MAGIC.1=magic; 
   PRICE=PRICE();      
   return(true);      
}

void CheckTrend()
{
   if(TIME()>TIME)
      TIME=TIME(); else return;
   int magic=MAGIC();
   if(WAVE.0(magic)) return;
   if(WAVE.1(magic)) return;   
   if(WAVE.2(magic)) return;
   double price=PRICE();
   double delta=price-PRICE;
   ARRAY[MAGIC.1][MAGIC.1]+=delta;
   ARRAY[MAGIC.2][MAGIC.1]+=delta;   
   MAGIC.2=MAGIC.1; MAGIC.1=magic;
   PRICE=price;
   Print(TimeToStr(TIME));   
}  

void init()
{
   ArrayInitialize(ARRAY,0);
   FILE=FileOpen(Symbol()+".BIN",FILE_BIN|FILE_READ|FILE_WRITE);
   FileReadArray(FILE,ARRAY,0,ArraySize(ARRAY));
   MAGIC.1=EMPTY;
   MAGIC.2=EMPTY;
}
  
void start()
{
   if(IsTradeAllowed()) CheckTrend();
}

void deinit()
{
   FileWriteArray(FILE,ARRAY,0,ArraySize(ARRAY));
   FileFlush(FILE);
   FileClose(FILE);
}

